#pragma once

#include "Renderer.h"

class UnstructuredGrid3D;



class MeshRenderer : public Renderer	//Renderer for displaying eigenvectors and eigenvalues computed
{										//on a 3D unstructured grid (mesh)
public:

enum DRAW_STYLE
{
    DRAW_GRID     =0,					//Draw the grid only. See the SimpleRenderer class.
	DRAW_C1_CELLS,						//Draw cells, using smooth shading (color interpolation)
	DRAW_C1_TEX_CELLS					//Draw cells, using texture-based scalar interpolation
};	

				MeshRenderer(): draw_style(DRAW_C1_TEX_CELLS),scale(1),normalize(false),show_vectors(true) 
				{ createTextures(); }

void			draw(Grid&);

void			setDrawingStyle(DRAW_STYLE s)
				{ draw_style = s; }

void			setVectorScale(float s)	//Set scale of vector glyphs (in world units)
				{ scale = s; }		

void			setNormalize(bool n)	//Draw vector glyphs normalized or not
				{ normalize = n; }		//(if normalized, all are 'scale' units long)

void			showVectors(bool v)		//Show the vector glyphs (atop the grid) or not
				{ show_vectors = v; }

protected:

void			drawGrid(UnstructuredGrid3D&);
void			drawC1Cells(UnstructuredGrid3D&);
void			drawC1TexCells(UnstructuredGrid3D&);
void			drawVectors(UnstructuredGrid3D&);
void			createTextures();

DRAW_STYLE		draw_style;
unsigned int	textureID;
float			scale;
bool			normalize;
bool			show_vectors;
};



						

