#pragma once

#include "Grid.h"
#include "ScalarAttributes.h"
#include "VectorAttributes.h"
#include <vector>

using namespace std;




class UnstructuredGrid : public Grid
{
public: 
					UnstructuredGrid(int P,int C): scalars(P),vectors(P)
					{
						pointsX.resize(P);
						pointsY.resize(P);
						cells.resize(3*C);
					}	 
					 	
int					numPoints()
					{ return pointsX.size(); }				 

int					numCells()	
					{ return cells.size()/3; }

void				getPoint(int i,float* p);

void				setPoint(int i,float* p);		

int					getCell(int cell,int* vertices); 

void				setCell(int cell,int* vertices);

int					findCell(float* p);

ScalarAttributes&	pointScalars()
					{ return scalars; }

VectorAttributes&	pointVectors()
					{ return vectors; }

protected:

ScalarAttributes	scalars;
VectorAttributes	vectors;
vector<float>		pointsX,pointsY;
vector<int>			cells;
};



